#ifndef MYHEADER_H
#define MYHEADER_H

#include <ultra64.h>
#include "math/vector.h"
#include "material.h"
#include "rectangle.h"

typedef enum {
	LAYERATTRIBUTE_NONE = 0x0,
	LAYERATTRIBUTE_PREVENT_SEAMS = 0x1,
} LayerAttributes;

typedef struct {
	uint16_t	material_id;
	Gfx const*	gfx;
	uint32_t	gfx_size;
	Vtx const*	vts;
	uint32_t	vts_size;
	Rectangle	tile;
	LayerAttributes	attr;
	uint32_t	vts_ofs;
} StaticLayer;

#define STATICLAYER_INIT( mtlid, gfxp, gfxs, vtsp, vtss, t, a ) \
{ .material_id = mtlid, .gfx = gfxp, .gfx_size = gfxs, .vts = vtsp, .vts_size = vtss, .tile = t, .attr = a, .vts_ofs = 0 }

typedef struct {
	StaticLayer*	layers;
	Material*		materials;
	Texture*		textures;
	uint16_t		num_layers;
	uint16_t		num_materials;
	uint16_t		num_textures;
	float			opacity;
} StaticMesh;

#define STATICMESH_INIT( lays, nlays, mtls, nmtls, texs, ntexs ) \
{ .layers = lays, .num_layers = nlays, .materials = mtls, .num_materials = nmtls, .textures = texs, .num_textures = ntexs, .opacity = 1.0f }

//void clone_Layer( Layer const* self, Layer* clone );

#endif
